%% ERGO COPYRIGHT NOTICE, LICENCE AND DISCLAIMER.
%%
%% Copyright 1993 by The University of Queensland, Queensland 4072 Australia
%% 
%% 
%% Permission to use, copy and distribute this software for any
%% non-commercial purpose and without fee is hereby granted, provided
%% that the above copyright notice and this permission notice and
%% warranty disclaimer appear in all copies and in supporting
%% documentation, and that the name of the University of Queensland not
%% be used in advertising or publicity pertaining to distribution of
%% the software without specific, written prior permission.
%% 
%% Source code modifications are prohibited except where written 
%% agreement has been given in advance by the University of Queensland.
%% 
%% The University of Queensland disclaims all warranties with regard to
%% this software, including all implied warranties of merchantability
%% and fitness.  In no event shall the University of Queensland be
%% liable for any special, indirect or consequential damages or any
%% damages whatsoever resulting from loss of use, data or profits,
%% whether in an action of contract, negligence or other tortious
%% action, arising out of or in connection with the use or performance
%% of this software.
%% 
%% CVS trans.ql,v 1.16 1993/12/10 02:23:49 marku Exp


?- op(920, xfy, (=>)).
?- op(810, xfy, (and)).
?- op(999, fx,  (h)).



/*
** All the ordinary trans's:
*/

trans(Rule)                           :- trans(Rule, f, _, []).
trans(Rule, Ant)                      :- trans(Rule, f, _, Ant).
trans_r(Rule)                         :- trans(Rule, r, _, []).
trans_r(Rule, Ant)                    :- trans(Rule, r, _, Ant).
trans_dir(Rule, Dir)                  :- trans(Rule, Dir, _, []).
trans_dir(Rule, Dir, Ant)             :- trans(Rule, Dir, _, Ant).
trans_goal(Rule, G)                   :- trans(Rule, _, G, []).
trans_goal(Rule, G, Ant)              :- trans(Rule, _, G, Ant).
trans_true(Rule)                      :- trans(Rule, t, true, []).
trans_true(Rule, Ant)                 :- trans(Rule, t, true, Ant).


h_trans(Name, Rule)                   :- h_trans(Name, Rule, f, _, [], _).
h_trans(Name, Rule, Ant)              :- h_trans(Name, Rule, f, _, Ant, _).
h_trans_r(Name, Rule)                 :- h_trans(Name, Rule, r, _, [], _).
h_trans_r(Name, Rule, Ant)            :- h_trans(Name, Rule, r, _, Ant, _).
h_trans_dir(Name, Rule, Dir)          :- h_trans(Name, Rule, Dir, _, [], _).
h_trans_dir(Name, Rule, Dir, Ant)     :- h_trans(Name, Rule, Dir, _, Ant, _).
h_trans_goal(Name, Rule, G)           :- h_trans(Name, Rule, _, G, []).
h_trans_goal(Name, Rule, G, Ant)      :- h_trans(Name, Rule, _, G, Ant).
h_trans_true(Name, Rule)              :- h_trans(Name, Rule, t, true, [], _).
h_trans_true(Name, Rule, Ant)         :- h_trans(Name, Rule, t, true, Ant, _).
h_trans(Name, Rule, Dir, G, Ant)      :- h_trans(Name, Rule, Dir, G, Ant, _).


d_trans(Name, Rule)                   :- d_trans(Name, Rule, f, true, []).
d_trans(Name, Rule, Ant)              :- d_trans(Name, Rule, f, true, Ant).
d_trans_r(Name, Rule)                 :- d_trans(Name, Rule, r, true, []).
d_trans_r(Name, Rule, Ant)            :- d_trans(Name, Rule, r, true, Ant).
d_trans_dir(Name, Rule, Dir)          :- d_trans(Name, Rule, Dir, true, []).
d_trans_dir(Name, Rule, Dir, Ant)     :- d_trans(Name, Rule, Dir, true, Ant).
d_trans_true(Name, Rule)              :- d_trans(Name, Rule, t, true, []).
d_trans_true(Name, Rule, Ant)         :- d_trans(Name, Rule, t, true, Ant).


take_theorem(Name)                    :- h_trans(true, Name, rt, _,  [], _).
take_theorem(Name, Th)                :- h_trans(true, Name, rt, Th, [], _).
take_theorem(Name, Th, No)            :- h_trans(true, Name, rt, Th, [], No).



/*
** The focus and hypothesis code
*/


trans(Rule, Dir, G, Ant) :-
        ipLookup(focuslist, [(F,J)|FL]),
        ipLookup(focusdep, FDep),
	ipLookup(relation,  Eq),
        thawing_new_vars( 
		trans(Rule, Rule2, Dir, Eq, F, G, Ant, Ant2, TDep)),
	'$collect_variables'((FDep, TDep), var, [], Dep),
	ipSet(focusdep, Dep),
        ipSet(focuslist, [(G, trans_dir(Rule2, Dir, Ant2)), (F, J) | FL]).


h_trans(Name, Rule, Dir, G, Ant, RNo) :-
        nonvar(Name),
        (Name == true, Dir = rt ->
            No = true,
            F  = true,
            FDep = []
        ;
            delete_hyp(Name, (No, F, _, _, FDep))
        ),
        thawing_new_vars(
                trans(Rule, Rule2, Dir, =>, F, G, Ant, Ant2, TDep)),
        '$collect_variables'((FDep, TDep), var, [], Dep),
        add_hyp(G, RNo, h_trans_dir(No, Rule2, Dir, Ant2), Dep).



d_trans(Name, Rule, Dir, true, Ant) :-
	nonvar(Name), 
        get_hyp(Name, (No, F, _, conjecture(_, J), FDep)),
	var(J),
	thaw([J, FDep]),
        thawing_new_vars(
                trans(Rule, Rule2, Dir, rev(=>), F, true, Ant, Ant2, FDep)),
	J = trans_dir(Rule2, Dir, Ant2).








/*
** The real banana:  NEVER CALL THIS PREDICATE
*/

trans(Rule, Rule2, Direction, Eq, F, G, Ant, Ant2, (D1, D2)) :-
	nonvar(Ant), 

	choose_conditional(Ant, RuleForm, Conds, Concl),
	choose_direction(Direction, Concl, F, RuleEq, GForm),

	get_th_or_hyp(Rule, Rule2, RuleForm, Body, D1),
	stronger(RuleEq, Eq),
        check_ant(Ant, Ant2, AntBody, Conds, D2),

	'$collect_variables'(GForm, var, [], GFVars),
	thawed_sublist(GFVars, [], NewVars),
        ipSet(newvars, NewVars), 

	G = GForm,
	once(with_frozen_nfi_test(on, (Body,AntBody))),
	incomplete_retry_delays, !.
		


%% choose_conditional(?Ant, ?Form, ?Conds, ?Concl).
%%
%%   This procedure splits up the entire statement of a rule (Form)
%%   into the conditions and the conclusion, according to CondFlag.
%%   It can also be used to construct Form from Conds and Concl.

choose_conditional([_|_],  A => B, A,     B).
choose_conditional([],     Form,   true,  Form).


%% choose_direction(?Direction, ?Concl, ?Input, ?RuleEq, ?Output).
%%
%%   This procedure splits up Concl into Input, RuleEq and Output,
%%   according to Direction.  It can also construct Concl from its parts.
%%   Direction will be one of: 'f', 'r', 't' or 'rt'.
%%

choose_direction(f,  Form,  F,    E,       G) :- Form =.. [E,F,G].
choose_direction(r,  Form,  F,    rev(E),  G) :- Form =.. [E,G,F].
choose_direction(t,  F,     F,    =,     true).
choose_direction(rt, F,     true, =,     F).


%% check_ant(+AntNames0, -AntNames, -Body, +AntPreds, -Dep).
%%
%%   Discharge any antecedents against the supplied list
	
check_ant([],    [], true, true, []) :- !.
check_ant([A], [A1], Body, Form, Dep) :-
	!, get_th_or_hyp(A, A1, Form, Body, Dep).

check_ant([A,B|C], [A1,B1|C1], (A_Body,BC_Body), A_Form and BC_Form, (D,D1)) :-
        get_th_or_hyp(A, A1, A_Form, A_Body, D), !,
	check_ant([B|C], [B1|C1], BC_Body, BC_Form, D1).


