%% ERGO COPYRIGHT NOTICE, LICENCE AND DISCLAIMER.
%%
%% Copyright 1993 by The University of Queensland, Queensland 4072 Australia
%% 
%% 
%% Permission to use, copy and distribute this software for any
%% non-commercial purpose and without fee is hereby granted, provided
%% that the above copyright notice and this permission notice and
%% warranty disclaimer appear in all copies and in supporting
%% documentation, and that the name of the University of Queensland not
%% be used in advertising or publicity pertaining to distribution of
%% the software without specific, written prior permission.
%% 
%% Source code modifications are prohibited except where written 
%% agreement has been given in advance by the University of Queensland.
%% 
%% The University of Queensland disclaims all warranties with regard to
%% this software, including all implied warranties of merchantability
%% and fitness.  In no event shall the University of Queensland be
%% liable for any special, indirect or consequential damages or any
%% damages whatsoever resulting from loss of use, data or profits,
%% whether in an action of contract, negligence or other tortious
%% action, arising out of or in connection with the use or performance
%% of this software.
%% 
%% CVS abbv.ql,v 1.6 1993/12/10 02:18:30 marku Exp



?- op(890,	 xfx,	 on_focus).
?- op(999,	 fx,	 h).
	

de_abbv(X, X) :-
	var(X),
	\+ (frozen(X)), !.

de_abbv(A, C) :-
	once(abbv(A, B)),
	\+ (A = B), !,
	de_abbv(B, C).

de_abbv(A, A) :- !.


/*
** The abbreviations
*/


%% abbv(use(Q),      	search_use(Q,_)).
%% abbv(use(Q,G),    	search_use((goal=G) and Q,_)).
%% abbv(use(Q,G,D),  	search_use((goal=G) and (discharge=D) and Q,_)).
%% 
%% abbv(fwd(Q),      	search_fwd(Q,_)).
%% abbv(fwd(Q,F),    	search_fwd((focus=F) and Q,_)).
%% abbv(fwd(Q,F,D),  	search_fwd((focus=F) and (discharge=D) and Q,_)).
%% 
%% abbv(print(Q),    	search_print(Q and print)).
%% abbv(print(Q,P),  	search_print(Q and print(P))).

abbv((A on_focus P),	focus(P, A)).
abbv(openwin(P), 	focus(P, _)).
abbv(closewin, 		set_goal).
abbv(close, 		set_goal).
% abbv(quit, 		set_goal).
abbv([A|B], 		focus(([A|B]), _)).
abbv(X, 		focus(X, _)) :- hyp_form(X).
abbv((X, [A|B]), 	focus((X, [A|B]),  _)) :- hyp_form(X).

abbv(subgoal(N), 	(meta(Old, New), _, meta(Old))).

abbv(focus(P, A), focus(P, B)) :-
	!, de_abbv(A, B).

abbv((A, B), (C, D)) :-
        !, de_abbv(A, C),
        de_abbv(B, D).

abbv(X, Y) :-
	X =.. [Functor|Args],
	length(Args, N),
	tactical_abbv((Functor/N), (NewFunc/M)), !,
	O is M - N,
	length(L, O),
	append(Args, L, NewArgs),
	Y =.. [NewFunc|NewArgs].
