%% ERGO COPYRIGHT NOTICE, LICENCE AND DISCLAIMER.
%%
%% Copyright 1993 by The University of Queensland, Queensland 4072 Australia
%% 
%% 
%% Permission to use, copy and distribute this software for any
%% non-commercial purpose and without fee is hereby granted, provided
%% that the above copyright notice and this permission notice and
%% warranty disclaimer appear in all copies and in supporting
%% documentation, and that the name of the University of Queensland not
%% be used in advertising or publicity pertaining to distribution of
%% the software without specific, written prior permission.
%% 
%% Source code modifications are prohibited except where written 
%% agreement has been given in advance by the University of Queensland.
%% 
%% The University of Queensland disclaims all warranties with regard to
%% this software, including all implied warranties of merchantability
%% and fitness.  In no event shall the University of Queensland be
%% liable for any special, indirect or consequential damages or any
%% damages whatsoever resulting from loss of use, data or profits,
%% whether in an action of contract, negligence or other tortious
%% action, arising out of or in connection with the use or performance
%% of this software.
%% 
%% CVS back.ql,v 1.9 1993/12/10 02:18:32 marku Exp



:- tactic(back(R, _), 
	  ['back(+Rule) -- backward chaining on Rule.',nl,
	   'NB. This is now superceeded by use/3'],
	  ['Backwards application of ', R], 
	  [['Subgoal ', 1] | _]
         ).

:- tactic(back(R, _, _, _), 
	  ['back(+Rule,?Direction,?Goal). ', nl,
	   'NB. This is now superceeded by use/3'],
          ['Backwards application of ', R], 
          [['Subgoal ', 1] | _]
	  ).



back(Thm) :- back(Thm, _).
back(Thm, Code) :-	
	back(Thm, t, true, Code).

back(Thm, Dir, Goal, HypCode) :-
	once   (is_focus(F),
		is_reln(E),
		number_of_hyps(Nr),
		thawing_new_vars(
		      once((back_thm(BE, Dir, F, Form, Goal, BT),
			    stronger(BE, E),
			    trans(BT, f, if(_, Goal, F), [Thm])))
 		      ),
		open_pos([1], 
		    (delete_new_hyps(Nr),
		     conjuncts(HypCode))),
		trans(r:iftrue)).


back_thm(  =, t, F, H => F,         true, r:back_thm).
back_thm(<=>, r, F, H => (X <=> F), X,    r:back_thm3).
back_thm(<=>, f, F, H => (F <=> X), X,    r:back_thm4).
back_thm(  =, f, F, H => (F = X),   X,    r:back_thm1).
back_thm(  =, r, F, H => (X = F),   X,    r:back_thm2).


/*
 * delete_new_hyps(N)
 *
 *      Deletes all hypotheses with numbers greater than N.
 */


delete_new_hyps(N) :-
	number_of_hyps(Top),
	delete_new_hyps(Top, N).

delete_new_hyps(N, N) :- !.
delete_new_hyps(T, N) :-
        Next is T - 1,
	once (delete_hyp(T) ; true),
        delete_new_hyps(Next, N).
