%% ERGO COPYRIGHT NOTICE, LICENCE AND DISCLAIMER.
%%
%% Copyright 1993 by The University of Queensland, Queensland 4072 Australia
%% 
%% 
%% Permission to use, copy and distribute this software for any
%% non-commercial purpose and without fee is hereby granted, provided
%% that the above copyright notice and this permission notice and
%% warranty disclaimer appear in all copies and in supporting
%% documentation, and that the name of the University of Queensland not
%% be used in advertising or publicity pertaining to distribution of
%% the software without specific, written prior permission.
%% 
%% Source code modifications are prohibited except where written 
%% agreement has been given in advance by the University of Queensland.
%%
%% The University of Queensland disclaims all warranties with regard to
%% this software, including all implied warranties of merchantability
%% and fitness.  In no event shall the University of Queensland be
%% liable for any special, indirect or consequential damages or any
%% damages whatsoever resulting from loss of use, data or profits,
%% whether in an action of contract, negligence or other tortious
%% action, arising out of or in connection with the use or performance
%% of this software.
%% 
%% CVS kcompare.ql,v 1.3 1993/12/10 02:21:44 marku Exp


%% Comparison test bed   T1 > T2


k_compare(A,B) :- kcompare(A,B).
%% k_compare(A,B) :- k_comp('>', A, B).

%%
%% Terms containing vars > Terms not containg vars
%%
%% Terms containing 1 var each, determined by local relation of 
%%       those vars
%%
%% Terms containing no vars related as per 'compare/2'
%%
%% Other terms undetermined.  (Failure not to be seen as negation)
%%

kcompare(T1, T2) :-
	varsin(T1, V1), 
	varsin(T2, V2),
	rev_tr(V1, RV1),   %% Making the assumption that the subterms are 
	rev_tr(V2, RV2),   %% sorted -- this is a false assumption
	kcompare(T1, RV1, T2, RV2).

kcompare(T1, [], T2, []) :-
 	compare('>', T1, T2), !.

kcompare(_T1, [], _T2, [_|_]) :- !.

%% kcompare(T1, V1, T2, V2) :-
%% 	V1 == V2,
%% 	compare('>', T1, T2), !.

%% kcompare(_T1, [A|As], _T2, [B|Bs]) :-
%% 	length([A|As], LA),
%% 	length([B|Bs], LB),

kcompare(_T1, [A|As], _T2, [B|Bs]) :-
	compare('>', [A|As], [B|Bs]), !.


	
k_comp(X, A, B) :- integer(A), not(integer(B)), !, X = '>'.
k_comp(X, B, A) :- integer(A), not(integer(B)), !, X = '<'.
k_comp(C, A, B) :- !, 
	mk_comp_copies(A, AC, B, BC),
	compare(C, AC, BC).


mk_cann_copy(A, AC, B, BC) :-
	functor(A, F, N),
	functor(B, F, N), !,
	nuffin.
	

	
		
