%% ERGO COPYRIGHT NOTICE, LICENCE AND DISCLAIMER.
%%
%% Copyright 1993 by The University of Queensland, Queensland 4072 Australia
%% 
%% 
%% Permission to use, copy and distribute this software for any
%% non-commercial purpose and without fee is hereby granted, provided
%% that the above copyright notice and this permission notice and
%% warranty disclaimer appear in all copies and in supporting
%% documentation, and that the name of the University of Queensland not
%% be used in advertising or publicity pertaining to distribution of
%% the software without specific, written prior permission.
%% 
%% Source code modifications are prohibited except where written 
%% agreement has been given in advance by the University of Queensland.
%% 
%% The University of Queensland disclaims all warranties with regard to
%% this software, including all implied warranties of merchantability
%% and fitness.  In no event shall the University of Queensland be
%% liable for any special, indirect or consequential damages or any
%% damages whatsoever resulting from loss of use, data or profits,
%% whether in an action of contract, negligence or other tortious
%% action, arising out of or in connection with the use or performance
%% of this software.
%% 
%% CVS lambda.ql,v 1.5 1993/12/10 02:18:51 marku Exp


?- op(900,quant,lambda).
?- object_var('x').

/*
** Warning - Evaluation \= functional unification!
*/


evaluate(A, C) :-
	eval(A, B),
	evaluate(B, C), !.
evaluate(A, A).

eval(app((lambda x A), B), [B/x]*A).
eval(app(A, B),            app(C, B)) :- eval(A, C).
eval(app(A, B),            app(A, C)) :- eval(B, C).
eval(lambda x A,           lambda x B) :- eval(A, B).



maplist([], _, []).
maplist([A|B], F, [C|D]) :-
	evaluate(app(F, A), C), 
	maplist(B, F, D).


/*
**  A prolog oriented, probably non confluent, evaluation for lambda calculus
**  which comes close to function unification when used in conjunction with
**  incomplete_retry_delays
*/

evaluate2(A, C) :-
        eval2(A, B),
        evaluate2(B, C), !.
evaluate2(A, A).

eval2(A, _) :- var(A), !, fail.
eval2(app((lambda x A), B), [D/x]*C) :- evaluate2(A, C),
					evaluate2(B, D).
eval2(app(A, B),            app(C, B)) :- eval2(A, C).
eval2(app(A, B),            app(A, C)) :- eval2(B, C).
eval2(lambda x A,           lambda x B) :- eval2(A, B).
eval2(lambda x A,           [_/x]*A).

