%% ERGO COPYRIGHT NOTICE, LICENCE AND DISCLAIMER.
%%
%% Copyright 1993 by The University of Queensland, Queensland 4072 Australia
%% 
%% 
%% Permission to use, copy and distribute this software for any
%% non-commercial purpose and without fee is hereby granted, provided
%% that the above copyright notice and this permission notice and
%% warranty disclaimer appear in all copies and in supporting
%% documentation, and that the name of the University of Queensland not
%% be used in advertising or publicity pertaining to distribution of
%% the software without specific, written prior permission.
%% 
%% Source code modifications are prohibited except where written 
%% agreement has been given in advance by the University of Queensland.
%% 
%% The University of Queensland disclaims all warranties with regard to
%% this software, including all implied warranties of merchantability
%% and fitness.  In no event shall the University of Queensland be
%% liable for any special, indirect or consequential damages or any
%% damages whatsoever resulting from loss of use, data or profits,
%% whether in an action of contract, negligence or other tortious
%% action, arising out of or in connection with the use or performance
%% of this software.
%% 
%% CVS tactics.ql,v 1.7 1993/12/10 02:19:11 marku Exp


:- tactic(eqv_cases(_),
	'eqv_cases -- split an <=> into => and <=',
	'Equivalence case analysis',
	[['Right'], ['Left']]
       ).

eqv_cases([L, R]) :-
	is_focus(_ <=> _), 
	is_goal(true),
	trans(r:def(<=>)),
	open_pos([1], (open_pos([2], L),  trans_true(r:imp_true))),
	trans(r:trueand),
	open_pos([2], R),
	trans_true(r:imp_true).

:- tactic(deny_focus(_),
	'deny_focus -- prove the focus by contradiction',
	'By contradiction',
	['']
        ).

deny_focus(CL) :-
        trans_dir(r:orparallel,r,[]),
	once(elem(C,CL)),
        C on_focus [1].


